/***************************************************************************
                          tdb_gdkpb.c  -  3D filesystem browser
                             -------------------
    begin                : Fri Feb 23 2001
    copyright            : (C) 2001 by Leander Seige
    email                : leander@hgb-leipzig.de
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/
/*
Everything here is released under the GPL (http://www.gnu.org/copyleft/gpl.html) and coded by Leander Seige.
I would like to develop this program myself so if you have bugreports, additional code, bugfixes,
suggestions, questions or something similar, please mail me: leander@hgb-leipzig.de .
*/

unsigned char * read_gdkpb (char * filename)
{
	GdkPixbuf *buff,*sbuff;
	unsigned char *data;
	int c,chan,bps;
	unsigned long int memsize;
	gboolean alpha;
	buff=gdk_pixbuf_new_from_file(filename);
	if ((buff==NULL)||(gdk_pixbuf_get_bits_per_sample(buff)<1))
        {
                printf("Cannot read image %s ! (file loading)\n",filename);
                www=0;hhh=0;chan=0;alpha=0;bps=0;ssi=NULL;
                p2w=0;p2h=0;
                return NULL;
        }
	www=gdk_pixbuf_get_width(buff); hhh=gdk_pixbuf_get_height(buff);

	if ((www<=0)||(hhh<=0))
        {
                gdk_pixbuf_unref(buff);
                printf("Cannot read image %s ! (identification error)\n",filename);
                www=0;hhh=0;chan=0;alpha=0;bps=0;ssi=NULL;
                p2w=0;p2h=0;
                return NULL;
        }

        for (cc=1; (cc<www||cc<hhh) && cc<TDFSB_MAX_TEX_SIZE; cc*=2); p2h=p2w=cc;
	sbuff=gdk_pixbuf_scale_simple(buff,p2w,p2h,GDK_INTERP_HYPER);

	if ((sbuff==NULL)||(gdk_pixbuf_get_bits_per_sample(sbuff)<1))
        {
                gdk_pixbuf_unref(buff); if (sbuff) gdk_pixbuf_unref(sbuff);
                printf("Cannot read image %s ! (error while scaling)\n",filename);
                www=0;hhh=0;chan=0;alpha=0;bps=0;ssi=NULL;
                p2w=0;p2h=0;
                return NULL;
        }

        gdk_pixbuf_unref(buff);
	data=gdk_pixbuf_get_pixels(sbuff); chan=gdk_pixbuf_get_n_channels(sbuff); alpha=gdk_pixbuf_get_has_alpha(sbuff); bps=gdk_pixbuf_get_bits_per_sample(sbuff);
	memsize=(unsigned long int)ceil(((double)((p2w*p2h*chan)*8))/((double)bps));
	if ((data==NULL)||(chan<1)||(bps<1))
        {
                gdk_pixbuf_unref(sbuff);
                printf("Cannot read image %s ! (identification error after scaling)\n",filename);
                www=0;hhh=0;chan=0;alpha=0;bps=0;ssi=NULL;
                p2w=0;p2h=0;
                return NULL;
        }

        if (!(ssi=(unsigned char *)malloc(memsize)))
        {
                gdk_pixbuf_unref(sbuff);
                printf("Cannot read image %s ! (low mem) \n",filename);
                www=0;hhh=0;chan=0;alpha=0;bps=0;ssi=NULL;
                p2w=0;p2h=0;
                return NULL;
        }
	for (c=0;c<(p2w*p2h*chan);c++) ssi[c]=data[c];

	gdk_pixbuf_unref(sbuff);

	if ((chan==3)&&(bps==8))        cglmode=GL_RGB;
	else if ((chan==4)&&(bps==8))   cglmode=GL_RGBA;
	else                            cglmode=GL_LUMINANCE;		/* not so nice... */

	return ssi;

}
